<?php
/**
 * Paky Feedback shortcode
 */

/**
 * Feedback List shortcode
 */
function paky_feedback_shortcode_list( $atts, $content = null ) {
	
	ob_start();
	
	paky_feedback_excerpt();
	
	$paged = ( get_query_var('paged') ) ? get_query_var('paged') : 1;
	$feed_per_page = paky_feedback_get_option( 'paky_feedback_max_list' );
	if ( $feed_per_page < 1) {
		$feed_per_page = -1;
	}
	$args = array( 'post_type' => 'paky-feedback', 'posts_per_page' => $feed_per_page, 'paged' => $paged );
	$loop = new WP_Query( $args );
	if ( $loop->have_posts() ) : ?>
		<div class="feedback-list">
			
			<?php while ( $loop->have_posts() ) : $loop->the_post(); ?>
  			<div class="row paky-feedback-slide">
				<div class="col-md-2">
					<?php $email = esc_html( get_post_meta( get_the_ID(), 'paky_feedback_submitted_author_email', true ) ); ?>
					<?php echo get_avatar( $email, 64 ); ?>
					<span class="author"><?php echo esc_html( get_post_meta( get_the_ID(), 'paky_feedback_submitted_author_name', true ) ); ?></span>
				</div>
				<div class="col-md-10">
					<?php $content_post = get_post( get_the_ID() ); ?>
					<span class="entry-date"><?php echo get_the_date( 'F j, Y', $content_post ); ?></span>
					<?php $content = $content_post->post_content; ?>
					<?php echo $content; ?>
					
					<?php
	
					$i = $stars = $starating = 0;
					$criterions = paky_feedback_get_option( 'paky_feedback_criterion' );
					if ( ! empty( $criterions ) ) {
						$starating = esc_html( get_post_meta( get_the_ID(), 'paky_feedback_star_rating_' . preg_replace( '/\s+/', '', $criterions ), true ) );
						echo paky_feedback_display_rating( $starating );
					}
					?>
					
					<?php $myreply = esc_html( get_post_meta( get_the_ID(), 'paky_feedback_admin_reply', true ) ); ?>
					<?php if ( ! empty( $myreply) ) { ?>
						
						<div class="admin-reply">
							<span class="entry-author"><?php echo get_the_author() . ' ' . esc_html__( 'Replies:', 'paky_feedback'); ?></span>
							<?php echo $myreply; ?>
						</div>
					<?php } ?>
				</div>
				
			</div>
			<?php endwhile; ?>
			<?php if ($loop->max_num_pages > 1) { // check if the max number of pages is greater than 1  ?>
			
			<?php	
			wp_enqueue_script(
 				'pbd-alp-load-posts',
 				plugin_dir_url( __FILE__ ) . 'js/paky-load-feedbacks.js',
 				array('jquery'),
 				'1.0',
 				true
 			);
 		
 		
 			// What page are we on? And what is the pages limit?
 			$max = $loop->max_num_pages;
 		
 			// Add some parameters for the JS.
 			wp_localize_script(
 				'pbd-alp-load-posts',
 				'pbd_alp',
 				array(
 					'startPage' => $paged,
 					'maxPages' => $max,
 					'nextLink' => next_posts($max, false)
 				)
 			);
			?>	
			
			<?php } ?>
			<?php wp_reset_postdata(); ?>
		</div>
	<?php endif; ?>
	
	<?php return ob_get_clean();
	
}
add_shortcode( 'paky-feedback-list', 'paky_feedback_shortcode_list' );

/**
 * Display rating excerpt
 */
function paky_feedback_excerpt() {
	$args = array( 'post_type' => 'paky-feedback' );
	$loop = new WP_Query( $args );
	if ( $loop->have_posts() ) :
		$criterions = paky_feedback_get_option( 'paky_feedback_criterion' );
		if ( ! empty( $criterions ) ) {
			$criterions = preg_replace( '/\s+/', '', $criterions );
			$count[$criterions] = 0;
			$star[$criterions] = 0;
		}
		
		while ( $loop->have_posts() ) : $loop->the_post();
	
			$criterions = paky_feedback_get_option( 'paky_feedback_criterion' );
			if ( ! empty( $criterions ) ) {
				
				$criterions = preg_replace( '/\s+/', '', $criterions );
				$starating = esc_html( get_post_meta( get_the_ID(), 'paky_feedback_star_rating_' . $criterions, true ) );
				$star[$criterions] = $star[$criterions] + $starating;
				if ( $starating > 0 ) {
					++$count[$criterions];
				}
			}
	
		endwhile;
		wp_reset_postdata();
	
	?>
		<div class="row paky-feedback-excerpt">
			<div class="col-md-6">
				<p><?php echo wp_count_posts( 'paky-feedback' )->publish . ' ' . esc_html__( 'Feedbacks', 'paky_feedback' ); ?></p>
			</div>
			<div class="col-md-6">
				<a class="pull-right" href="<?php echo esc_url( paky_feedback_get_option( 'paky_feedback_form_page_url' ) ); ?>"><?php esc_html_e( 'Leave a feedback', 'paky_feedback' ); ?></a>
			</div>
			
			<div class="col-md-7">
				<span class="paky-rating-table-title"><?php esc_html_e( 'Feedback Criterions', 'paky_feedback' ); ?></span>
				<table class="paky-rating-table">
					<?php
					$media[] = array();
					$criterions = paky_feedback_get_option( 'paky_feedback_criterion' );
					if ( ! empty( $criterions ) ) {
						
						$criterion1 = preg_replace( '/\s+/', '', $criterions );
						
						if ( $count[$criterion1] > 0 ) {
							$media[$criterion1] = $star[$criterion1] / $count[$criterion1];
						} else { 
							$media[$criterion1] = 0;
						}
					
						?>
						<tr>
							<td>
								<?php echo $criterions.' (' . $count[$criterion1] . ')'; ?>
							</td>
							<td>
								<?php echo paky_feedback_display_rating( $media[$criterion1], 1 ); ?>
							</td>
							<td class="right">
								<?php echo number_format($media[$criterion1], 2); ?>
							</td>
						</tr>
					<?php } ?>
					<?php
					$criterions = paky_feedback_get_option( 'paky_feedback_criterion' );
					$i = $media_temp = 0;
					if ( ! empty( $criterions ) ) {
						$criterion1 = preg_replace( '/\s+/', '', $criterions );
						$media_temp += $media[$criterion1];
						if ( $media[$criterion1] > 0 ) {
							++$i;
						}
					}
					?>
					<tr>
						<td class="bold">
							<?php esc_html_e( 'Global Rating', 'paky_feedback' ); ?>
						</td>
						<td>
							<?php echo paky_feedback_display_rating( number_format($media_temp / $i, 2), 1 ); ?>
						</td>
						<td class="bold right">
							<?php echo number_format($media_temp / $i, 2); ?>
						</td>
					</tr>
					
				</table>
			</div>
			<div class="col-md-5">
				<div class="paky-rating-sum">
					<?php echo paky_feedback_display_rating( number_format($media_temp / $i, 2), 1 ); ?>
					<span class="paky-rating-sum-1"><?php echo paky_feedback_display_rating( number_format($media_temp / $i, 2), 2 ); ?></span>
					<span class="paky-rating-sum-2"><?php echo number_format($media_temp / $i, 2); ?>/5.00</span>
				</div>
			</div>
		</div>
	<?php endif;
}

/*
 * Fix Shortcodes
 */
if( !function_exists('paky_feedback_fix_shortcodes') ) {
	function paky_feedback_fix_shortcodes($content){
		$array = array (
			'<p>['		=> '[', 
			']</p>'		=> ']', 
			']<br />'	=> ']'
		);
		$content = strtr($content, $array);
		return $content;
	}
}
add_filter('the_content', 'paky_feedback_fix_shortcodes');
